%MACRO UstrMcmp (Str1, Str2); %* (C) Jim Groeneveld, 13may2011 - 22jun2011;
%* Macro UstrMcmp compares two macro strings case-insensitive up to their shortest length;
%IF (%LENGTH(&Str1) AND %LENGTH(&Str2)) %THEN
%EVAL(%UPCASE(%SUBSTR(&Str1,1,%SYSFUNC(MIN(%LENGTH(&Str1),%LENGTH(&Str2))))) EQ
      %UPCASE(%SUBSTR(&Str2,1,%SYSFUNC(MIN(%LENGTH(&Str1),%LENGTH(&Str2))))));
%ELSE 0;     
%MEND UstrMcmp;

/* --- examples ---
%PUT (1)=%UstrMcmp(abcde,ABC);
%PUT (0)=%UstrMcmp(abcde,ABCe);
%PUT (1)=%UstrMcmp(abc,ABCDE);
--- */
